import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface TlsProviderConfig {
    /**
    * Alias name
    *
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/tls#alias TlsProvider#alias}
    */
    readonly alias?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/tls tls}
*/
export declare class TlsProvider extends cdktf.TerraformProvider {
    static readonly tfResourceType = "tls";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/tls tls} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options TlsProviderConfig = {}
    */
    constructor(scope: Construct, id: string, config?: TlsProviderConfig);
    private _alias?;
    get alias(): string | undefined;
    set alias(value: string | undefined);
    resetAlias(): void;
    get aliasInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
